use std::time::Duration;

use super::BenchmarkResult;
type MatrixReport = Vec<Vec<String>>;

pub fn create_header() -> std::iter::Once<Vec<String>> {
    std::iter::once(vec![
        "Day".to_string(),
        "Task".to_string(),
        "How long (Seconds:Mili)".to_string(),
        "Expected".to_string(),
        "Actual".to_string(),
    ])
}

pub fn create_sum_row(sum: Duration) -> std::iter::Once<Vec<String>> {
    let passed_txt = BenchmarkResult::convert_duration_to_secs_and_mili_txt(sum);
    std::iter::once(vec![
        "Total".to_string(),
        "Total".to_string(),
        passed_txt,
        "-".to_string(),
        "-".to_string(),
    ])
}

pub fn create_average_row(average: Duration) -> std::iter::Once<Vec<String>> {
    let passed_txt = BenchmarkResult::convert_duration_to_secs_and_mili_txt(average);
    std::iter::once(vec![
        "Average".to_string(),
        "Average".to_string(),
        passed_txt,
        "-".to_string(),
        "-".to_string(),
    ])
}

pub fn create_rows_for_every_solutions(loaded: Vec<BenchmarkResult>) -> MatrixReport {
    let after_header = loaded
        .into_iter()
        .map(|result| {
            vec![
                result.day().to_string(),
                result.task().to_string(),
                result.how_long_as_string(),
                result.expected_output().to_string(),
                result
                    .maybe_different_actual_output()
                    .map(|unowned| unowned.to_string())
                    .unwrap_or_else(|| result.expected_output().to_string()),
            ]
        })
        .collect();
    after_header
}
